//DxPolygon.h
#ifndef  __DXPOLYGON_H
#define  __DXPOLYGON_H

#include <vector>

namespace DataType
{
	extern int Type;
	extern int WireType;

	struct Vertex
	{
		float   x, y, z; 
		float   nx, ny, nz;
		DWORD   color; 
        float      u;
        float      v;
	};

	struct WireVertex
	{
		float x, y, z; 
		int   color; 
	};

	class Point3
	{
	public:
		float x, y, z;
		Point3( float _x, float _y, float _z )
		{
			x = _x; y = _y; z = _z;
		}
	};
};

typedef std::vector< DataType::Point3 >  PointArray;
class DxPolygon
{
public:
	DxPolygon();
	virtual ~DxPolygon();

	void	SetVertex( DataType::Vertex* pVertex, int nNum );
	void	Render( const LPDIRECT3DDEVICE9 device );
	void	PushBackPosition( DataType::Point3& pos );
	void	PushBackNormal( DataType::Point3& pos );

	
	PointArray& GetPosition() { return  m_position;  }
	PointArray& GetNormal() { return  m_normal;  }
	void	SetColor( DWORD color )  
	{ 
		m_color = color;  
	}

	void    TestTransform( float x, float y, float z );
	void	ClipAxis( float nx, float ny, float nz, float basis );



protected:
	void	Cleanup();
	void	CopyData();
	void	ReComputeNormal();

	DataType::Vertex* m_pVertex;
	DataType::WireVertex* m_pWireVertex;
	int		m_nCount;

	DWORD		m_color;
	PointArray  m_position;
	PointArray  m_normal;
};

#endif
