//collision.h
#ifndef _COLLISION_H
#define _COLLISION_H

#include <assert.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <vector>

typedef std::vector< D3DXVECTOR3 > VertexContainer;

struct OBB
{
	D3DXVECTOR3		center;
	//D3DXVECTOR3	orientation[3]; //Local X, Y, Z
	D3DXMATRIX		orientation;
	D3DXVECTOR3		extent;			//HalfWidth Extent
};

struct Sphere {
    D3DXVECTOR3		center;
    float			radius;
};

bool IsColinearTriangle( D3DXVECTOR3* p0, D3DXVECTOR3* p1, D3DXVECTOR3* p2, float epsilon=0.999f );
void ConsolidatePolygon( VertexContainer& out, VertexContainer& in );
bool TestSphereOBB( const Sphere& s, const OBB& b, D3DXVECTOR3* p );
bool TestObbAndObb( const OBB& a, const OBB& b );


#endif


