#include <windows.h>
#include <stdio.h>
#include "dxfunc.h"
#include "resource.h"
#include "collision.h"
#include "dbgstream.h"

#define    XSIZE     900
#define    YSIZE     600

LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK RenderWndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK DialogProc (HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);
void InitDialog (HWND hWnd, HINSTANCE hInst);


char szClassName[] = "Basic class";    // Ŭ
char szRenderClassName[] = "Render class";
BOOL		g_bActive = TRUE;
HWND        g_hWnd  = NULL;
HWND        g_hRenderWnd = NULL;
HINSTANCE   g_hInst = NULL;
HWND        g_hDlg = NULL;



ATOM InitApp (HINSTANCE hInst)
{
	{
		WNDCLASSEX wc;
		wc.cbSize = sizeof(WNDCLASSEX);
		wc.style =  CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc = RenderWndProc;  
		wc.cbClsExtra = 0;
		wc.cbWndExtra = 0;
		wc.hInstance = hInst;
		wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
		wc.hCursor = LoadCursor(NULL, IDC_ARROW);
		wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
		wc.lpszMenuName = NULL;   
		wc.lpszClassName = (LPCSTR) szRenderClassName;
		wc.hIconSm  = NULL;
		RegisterClassEx( &wc );
	}

    WNDCLASSEX wc;
    wc.cbSize = sizeof(WNDCLASSEX);
    wc.style =  CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WndProc;  
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInst;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH) GetStockObject(BLACK_BRUSH);
    wc.lpszMenuName = "MAINMENU";    
    wc.lpszClassName = (LPCSTR) szClassName;
    wc.hIconSm  = NULL;
    return (RegisterClassEx(&wc));
}

BOOL InitInstance (HINSTANCE hInst, int nCmdShow)
{
    HWND hWnd;

    hWnd = CreateWindow(szClassName,
            " ǥ",
            WS_OVERLAPPEDWINDOW & ~WS_THICKFRAME & ~WS_MAXIMIZEBOX,
            CW_USEDEFAULT,    
            CW_USEDEFAULT,    
            XSIZE,    
            YSIZE,    
            NULL, 
            NULL, //޴ ڵ, Ŭ ޴   NULL
            hInst, 
            NULL);
    if (! hWnd)
        return FALSE;

	g_hWnd = hWnd;

    g_hRenderWnd = CreateWindow(szRenderClassName, 
			NULL, 
			WS_CHILD | WS_VISIBLE, 
			10,        
			10,        
			100,
			100,
			hWnd,
			NULL,    
			hInst,
			NULL);

    ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);
    return TRUE;
}

void TestConsolidatePolygon()
{
	VertexContainer in, out;
	in.push_back( D3DXVECTOR3( 0, 0, 0 ) );
	in.push_back( D3DXVECTOR3( 1, 0, 0 ) );
	in.push_back( D3DXVECTOR3( 2, 0, 0 ) );
	in.push_back( D3DXVECTOR3( 0, 2, 0 ) );

	ConsolidatePolygon( out, in );
	
	int nCount = (int)out.size();
	dbg << "Vertext number: " << nCount << std::endl;

	for( int i = 0; i < nCount; ++i )
	{
		dbg << 	out[i].x << ",  " << out[i].y << ",  " <<  out[i].z << std::endl;
	}
}

int WINAPI WinMain (HINSTANCE hCurInst, HINSTANCE hPrevInst, LPSTR lpsCmdLine, int nCmdShow)
{
    MSG msg;
    
	//TestConsolidatePolygon();

    g_hInst = hCurInst;
    if (! InitApp(hCurInst))
        return FALSE;

    if (! InitInstance(hCurInst, nCmdShow)) 
        return FALSE;

	if(InitD3D(g_hWnd)!= S_OK )
		return -1;
	SetupCamera( g_hRenderWnd );
	InitDirectionalLight();

	if(!RenderInit())
		return -1;

	BOOL bGotMsg;

	msg.message = WM_NULL;
	PeekMessage( &msg, NULL, 0U, 0U, PM_NOREMOVE );
    while( WM_QUIT != msg.message  )
    {
        // Use PeekMessage() if the app is active, so we can use idle time to
        // render the scene. Else, use GetMessage() to avoid eating CPU time.
        if( g_bActive )
            bGotMsg = PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE );
        else
            bGotMsg = GetMessage( &msg, NULL, 0U, 0U );

        if( bGotMsg )
        {
            // Translate and dispatch the message
            //if( 0 == TranslateAccelerator( g_hWnd, hAccel, &msg ) )
            {
                TranslateMessage( &msg );
                DispatchMessage( &msg );
            }
        }
        else
        {
            // Render a frame during idle time (no messages are waiting)
            if( g_bActive )//&& m_bReady )
            {
                if( FAILED( RenderLoop()))
                    SendMessage( g_hWnd, WM_CLOSE, 0, 0 );
            }
        }
    }

/*
    while (GetMessage(&msg, NULL, 0, 0))
	{
		if ((g_hDlg== 0) || ! IsDialogMessage(g_hDlg, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
    }
*/

	UnregisterClass( szRenderClassName, hCurInst);
	UnregisterClass( szClassName, hCurInst);

    return 0;
}


LRESULT CALLBACK RenderWndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg) 
	{
    case WM_CREATE:
		{
			RECT rc, dlgrc;
			GetWindowRect(g_hWnd, &rc);	
			int xSize = rc.right - rc.left - 17;
			int ySize = rc.bottom - rc.top - 63;

			GetWindowRect(g_hDlg, &dlgrc);
			MoveWindow(hWnd, 5, 5, xSize - (dlgrc.right - dlgrc.left), ySize, TRUE);			
		}
        break;

    default:
          return (DefWindowProc(hWnd, msg, wParam, lParam));
    }
    return 0;
}


LRESULT CALLBACK WndProc (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
    switch (msg) 
	{
		case WM_ACTIVATE:
			g_bActive = LOWORD(wParam);
			return 0;
        case WM_CREATE:
			InitDialog(hWnd, g_hInst);
            break;
        case WM_COMMAND:
            switch (LOWORD(wParam)) 
			{
                case IDM_EXIT:
                    SendMessage(hWnd, WM_CLOSE, 0, 0);
                    break;
				case IDM_ORTHO_TOP_VIEW:
					SetupTopView();
					SetupOrthoProjection( g_hRenderWnd  );
					break;
				case IDM_ORTHO_QUARTER_VIEW:
					SetupQuarterView();
					SetupOrthoProjection( g_hRenderWnd  );
					break;
				case IDM_PROJECTIVE_TOP_VIEW:
					SetupTopView();
					SetupProjectiveProjection( g_hRenderWnd  );
					break;
				case IDM_PROJECTIVE_QUARTER_VIEW:
					SetupQuarterView();
					SetupProjectiveProjection( g_hRenderWnd  );
					break;
				case IDM_ROTATE_MODEL:
					SetRotateModel();
					break;
                default:
					break;
            }
			break;
/*
		case WM_PAINT:
			{
				HDC    hdc;
				PAINTSTRUCT ps;
				hdc=BeginPaint(hWnd, &ps);
				SetTextColor(hdc, RGB(255, 50, 50));
				SetBkColor(hdc, RGB(50, 255, 50));
				TextOut(hdc, 360, 200, "WM_PAINT Դϴ...", (int)strlen("WM_PAINT Դϴ..."));
				EndPaint(hWnd, &ps);
			    return 0;
			}
*/
        case WM_CLOSE:
			DestroyDirect();
            DestroyWindow(hWnd);
            break;
        case WM_DESTROY:
            PostQuitMessage(0);
            break;
          
        default:
            return (DefWindowProc(hWnd, msg, wParam, lParam));
    }
    return 0;
}
//------------------------------------------------------------------------------------------
extern void ClipModel( float nx, float ny, float nz, float basis );
bool Do_WM_COMMAND (WPARAM wParam, LPARAM lParam)
{
	int id;
	id = LOWORD(wParam);

    switch (id) 
	{
	case IDB_CLIP:
		{
			float nx, ny, nz, basis;
			
			char szStr[MAX_PATH];
			GetDlgItemText( g_hDlg, IDE_NX, szStr, MAX_PATH ); 
			nx = (float)atof( szStr );
			GetDlgItemText( g_hDlg, IDE_NY, szStr, MAX_PATH ); 
			ny = (float)atof( szStr );
			GetDlgItemText( g_hDlg, IDE_NZ, szStr, MAX_PATH ); 
			nz = (float)atof( szStr );
			GetDlgItemText( g_hDlg, IDE_BASIS, szStr, MAX_PATH ); 
			basis = (float)atof( szStr );
			ClipModel( nx, ny, nz, basis );
            return true;
		}
	}

    return false;
}
//------------------------------------------------------------------------------------------
LRESULT CALLBACK DialogProc (HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg) 
	{
    case WM_INITDIALOG:
		return TRUE;
    case WM_COMMAND:
		Do_WM_COMMAND(wParam, lParam);
		return TRUE;
	default:
		break;
	}
	return FALSE;
}
//------------------------------------------------------------------------------------------
void InitDialog (HWND hWnd, HINSTANCE hInst)
{
	RECT rc;
	int  xSize, ySize;
    
	if (g_hDlg)
		   return;
    g_hDlg = CreateDialog(hInst, "MAINDLG", hWnd, (DLGPROC) DialogProc);
    if (g_hDlg) 
	{
          ShowWindow(g_hDlg, SW_SHOW);
          GetWindowRect(g_hDlg, &rc);
          xSize = rc.right - rc.left + 1;
          ySize = rc.bottom - rc.top + 1;
          GetClientRect(hWnd, &rc);
          MoveWindow(g_hDlg, rc.right - xSize + 1, rc.top, xSize, rc.bottom, TRUE);	

		  SetDlgItemText( g_hDlg, IDE_NX, "0" );
		  SetDlgItemText( g_hDlg, IDE_NY, "0" );
		  SetDlgItemText( g_hDlg, IDE_NZ, "0" );
		  SetDlgItemText( g_hDlg, IDE_BASIS, "0" );
    } 
}
